<?php

require_once "ngwiki.php";

$script_name = $_SERVER["SCRIPT_NAME"];
$pagename = @urldecode(substr($_SERVER["PATH_INFO"], 1));
if (!$pagename) {
    $pagename = $default_page;
}

if (isset($_GET["action"])) {
    $action = $_GET["action"];
} else {
    $action = $default_action;
}

$title = $pagename;
$content = "";
$footer = "";
if ($action == "ViewPage") {
    $page = Wiki::getPage($pagename);
    $title = Formatter::link_to($pagename, "BackLinks"); 
    $content = parse($page->content);
    $footer = "<p>".Formatter::link_to($pagename, "EditPage", "EditText")." of this page (last edited ".date("Y-m-d", $page->edited_at).")</p>";
} else if ($action == "EditPage") {
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        $page = new Page($pagename);
        $page->content = stripslashes($_POST["text"]);
        $page->save();
        header("Location: $script_name/$pagename?action=ViewPage");
        exit;
    } else {    
        $page = Wiki::getPage($pagename);
        $title = "Editing $pagename";
        $content = "<form method=\"post\" action=\"$script_name/$pagename?action=EditPage\" name=\"edit\" id=\"edit\">\n";
        $content .= "<p><textarea name=\"text\" cols=\"80\" rows=\"15\">$page->content</textarea></p>\n";
        $content .= "<p><input type=\"submit\" value=\"Edit\" /></p>";
        $content .= "</form>";
        $footer = "<p>".Formatter::link_to($pagename, "ViewPage", "View this page")."</p>";
    }
} else if ($action == "BackLinks") {
    $title = "Back links of $pagename";
    $pages = Wiki::searchPage($pagename);
    $content = "<ul>";
    if (!$pages) {
        $content .= "<li><em>(no backlinks)</em></li>";
    } else {
        foreach ($pages as $page) {
            $content .= "<li>".Formatter::link_to($page->name)."</li>";
        }
    }
    $content .= "</ul>";
    $footer = "<p><a href=\"$script_name/$pagename?action=ViewPage\">&laquo; View this page</a> | <a href=\"$script_name/$pagename?action=EditPage\">EditText</a> of this page</p>";
}

include "include/header.php";
print $content;
include "include/footer.php";

?>
