<?php

define("NGWIKI_VERSION", "0.1cvs");
require "config.php";
require "parser.php";
require "formatter.php";
require "macros.php";

function _read($filename) {
    $buffer = "";
    $fp = @fopen($filename, "r");
    if (!$fp) return "";
    while (!feof($fp)) {
        $buffer .= fgets($fp, 1024);
    }
    fclose($fp);
    return $buffer;
}
function _write($filename, $content) {
    $fp = @fopen($filename, "w");
    if ($fp) {
        fwrite($fp, $content);
        fclose($fp);
    }
}

class Wiki
{
    /*static*/ function getPage($pagename)
    {
        $page = new Page($pagename);
        $page->content = _read($page->_filename());
        $page->edited_at = @filemtime($page->_filename());
        return $page;
    }
    /*static*/ function getPageList()
    {
        global $data_dir;
        $dir = opendir($data_dir);
        $list = array();
        while ($file = readdir($dir)) {
            $filename = $data_dir."/".$file;
            if ($file[0] == '.' || $file[0] == '_' || is_dir($filename)) {
                continue;
            }
            $list[] = urldecode($file);
        }
        return $list;
    }
    /*static*/ function searchPage($keyword)
    {
        global $data_dir;
        $list = Wiki::getPageList();
        $new_list = array();
        foreach ($list as $pagename) {
            $page = Wiki::getPage($pagename);
            if (strpos($page->content, $keyword) !== FALSE) {
                $new_list[] = $page;
            }
        }
        return $new_list;
    }
    function addChange($page) {
        global $data_dir;
        $date = time();
        $file = $data_dir . '/_changes';
        _write($file, "$date $page->name\n"._read($file));
    }
    function getChanges($count) {
        global $data_dir;
        $changes = array();
        $fp = fopen($data_dir . '/_changes', 'r');
        for ($i = 0; $i < $count; $i++) {
            $line = fgets($fp);
            if (!$line) break;
            $changes[] = explode(" ", rtrim($line), 2);
        }
        fclose($fp);
        return $changes;
    }
}

class Page
{
    var $name;
    var $content;
    function Page($name)
    {
        $this->name = $name;
    }
    function save()
    {
        _write($this->_filename(), $this->content);
        Wiki::addChange($this);
    }
    function _filename()
    {
        global $data_dir;
        return $data_dir . "/" . urlencode($this->name);
    }
}

?>
